<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

class modCommerceSellersHelper
{
	function getSellers($section_id)
	{
		$db	=& JFactory::getDBO();

		$CP = ResHelper::getSectionParams($section_id);
		$sellers = array();

		$sql = "SELECT id FROM #__users WHERE usertype IN ('Super Administrator', 'Administrator', 'Manager')";
		$db->setQuery($sql);
		$res = $db->loadResultArray();
		$sellers = array_merge($sellers, $res);

		if($CP->get('comm_confirm_field'))
		{
			$confirm = $CP->get('comm_confirm_field');
			if(!is_array($confirm))
			$confirm = explode(',', $CP->get('comm_confirm_field'));
			$sql = "SELECT u.id
			FROM #__juser_extended_data ex
			JOIN #__users u ON u.id = ex.user_id 
			WHERE ex.field_id = '".$confirm[0]."'
			AND ex.fvalue ".$confirm[1]." '".$confirm[2]."'";
			$db->setQuery($sql);
			$res = $db->loadResultArray();
			$sellers = array_merge($sellers, $res);
		}
		if($CP->get('comm_subscr_field'))
		{
			$confirm = $CP->get('comm_subscr_field');
			if(!is_array($confirm))
			$confirm = explode(',', $CP->get('comm_subscr_field'));

			$sql = "SELECT u.id, u.username, IF(s.access_limit > 0, (IF(s.access_limit >= s.access_count, 1, 0) ), 1) as access
			FROM #__jcs_user_subscr AS s
			JOIN #__users AS u ON u.id = s.user_id 
			WHERE s.subscription_id IN (".implode(', ', $confirm).")
			AND s.extime > NOW() AND s.ctime <= NOW() AND s.published = 1 GROUP BY s.user_id HAVING access > 0";
			$db->setQuery($sql);
			$res =  $db->loadObjectList();
			foreach ($res as $val)
			{
				$sellers[] = $val->id;
			}
		}
		if($CP->get('comm_enable_silver', 0))
		{
			if($CP->get('comm_confirm_silver'))
			{
				$confirm = $CP->get('comm_confirm_silver');
				if(!is_array($confirm))
				$confirm = explode(',', $CP->get('comm_confirm_silver'));

				$sql = "SELECT u.id
				FROM #__juser_extended_data ex
				JOIN #__users u ON u.id = ex.user_id
				WHERE ex.field_id = '".$confirm[0]."'
				AND ex.fvalue ".$confirm[1]." '".$confirm[2]."'";
				$db->setQuery($sql);
				$res = $db->loadResultArray();
				$sellers = array_merge($sellers, $res);
			}
			if($CP->get('comm_subscr_silver'))
			{
				$confirm = $CP->get('comm_subscr_silver');
				if(!is_array($confirm))
				$confirm = explode(',', $CP->get('comm_subscr_silver'));
					
				$sql = "SELECT u.id, u.username, IF(s.access_limit > 0, (IF(s.access_limit >= s.access_count, 1, 0) ), 1) as access
				FROM #__jcs_user_subscr AS s
				JOIN #__users AS u ON u.id = s.user_id 
				WHERE s.subscription_id IN (".implode(', ', $confirm).")
				AND s.extime > NOW() AND s.ctime <= NOW() AND s.published = 1 GROUP BY s.user_id HAVING access > 0";

				$db->setQuery($sql);
				$res =  $db->loadObjectList();
				foreach ($res as $val)
				{
					$sellers[] = $val->id;
				}
			}
		}

		if($CP->get('comm_enable_gold', 0))
		{
			if($CP->get('comm_confirm_gold'))
			{
				$confirm = $CP->get('comm_confirm_gold');
				if(!is_array($confirm))
				$confirm = explode(',', $CP->get('comm_confirm_gold'));

				$sql = "SELECT u.id
				FROM #__juser_extended_data ex
				JOIN #__users u ON u.id = ex.user_id
				WHERE ex.field_id = '".$confirm[0]."'
				AND ex.fvalue ".$confirm[1]." '".$confirm[2]."'";
				$db->setQuery($sql);
				$res = $db->loadResultArray();
				$sellers = array_merge($sellers, $res);
			}
			if($CP->get('comm_subscr_gold'))
			{
				$confirm = $CP->get('comm_subscr_gold');
				if(!is_array($confirm))
				$confirm = explode(',', $CP->get('comm_subscr_gold'));
					
				$sql = "SELECT u.id, u.username, IF(s.access_limit > 0, (IF(s.access_limit >= s.access_count, 1, 0) ), 1) as access
				FROM #__jcs_user_subscr AS s
				JOIN #__users AS u ON u.id = s.user_id 
				WHERE s.subscription_id IN (".implode(', ', $confirm).")
				AND s.extime > NOW() AND s.ctime <= NOW() AND s.published = 1 GROUP BY s.user_id HAVING access > 0";

				$db->setQuery($sql);
				$res =  $db->loadObjectList();
				foreach ($res as $val)
				{
					$sellers[] = $val->id;
				}
			}
		}
		$sellers = array_unique($sellers);
		$list = array();
		$API = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
		if(file_exists($API))
		{
			require_once $API;
		}
		foreach ($sellers as $i => $seller)
		{
			if(modCommerceSellersHelper::checkRecords($seller, $section_id))
			{
				$seller = JFactory::getUser($seller);
				$seller->uname = $seller->name;
				if(class_exists('JSCommunityApi'))
				{
					$seller->uname = JSCommunityApi::getUserSlideMenu($seller->id, $seller->name);
				}
				else
				{
					$js_user = JPATH_ROOT.DS.'components'.DS.'com_juser'.DS.'juser.php';
					if(file_exists($js_user))
					{
						$link = 'index.php?option=com_juser&view=userlist&layout=profile&id='.$seller->id.'&Itemid='.JRequest::getInt('Itemid');
						$seller->uname = JHTML::link(JRoute::_($link, false), $seller->name);
					}
				}
				$list[] = $seller;
			}
		}

		return $list;
	}

	function checkRecords($seller, $section_id)
	{
		$db	=& JFactory::getDBO();
		$sql = "SELECT COUNT(*) FROM #__js_res_record r
		JOIN #__js_res_record_category rc ON r.id = rc.record_id
		WHERE r.user_id = '$seller' AND rc.catid = '$section_id'";
		$db->setQuery($sql);
		$res = $db->loadResult();
		if(!$res)
		{
			$sql = "SELECT COUNT(*) FROM #__js_res_record r
			JOIN #__js_res_record_category rc ON r.id = rc.record_id
			JOIN #__js_res_category cat ON rc.catid = cat.id
			WHERE r.user_id = '$seller' AND cat.parent = '$section_id'";
			$db->setQuery($sql);
			$res = $db->loadResult();
		}
		return $res;
	}

}
